package fr.inra.pappso.FastaManager.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JOptionPane;
import javax.swing.JFileChooser;
import javax.swing.JTextField;
import javax.swing.SpringLayout;

import org.w3c.dom.Element;

import fr.inra.pappso.FastaManager.database.Repository;
import fr.inra.pappso.FastaManager.database.RepositoryWebdav;
import fr.inra.pappso.FastaManager.database.RepositorysLocation;
import fr.inra.pappso.FastaManager.exception.FastaException;

public class repository_window extends JDialog {

	private static final long serialVersionUID = 1L;

	private Repository repo = null;
	
	private String typeRepository;
	
	private RepositorysLocation repositories;

	private actions ab = new actions();

	private JTextField repertoire = new JTextField();
	
	private JTextField signet = new JTextField();
	
	private JTextField login = new JTextField();
	
	private JTextField password = new JTextField();

	public repository_window(JFrame owner, boolean modal, Repository x) {
		super(owner, modal);
		this.repo = x;
		// initialise la fenetre

		initialiseWebDav();

		// regle et affiche la fenetre
		setSize(400, 150);
		setLocationRelativeTo(owner);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setVisible(true);
	}
	
	public repository_window(JFrame owner, boolean modal, RepositorysLocation repositories, String typeRepository) {
		super(owner, modal);
		this.typeRepository = typeRepository;
		this.repositories = repositories;
		
		// initialise la fenetre
		if(typeRepository.equals(RepositorysLocation.LocalRepository))
			initialiseLocal();
		else if (typeRepository.equals(RepositorysLocation.WebdavRepository))
			initialiseWebDav();

		// regle et affiche la fenetre
		setLocationRelativeTo(owner);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setVisible(true);
	}
	
	private void initialiseWebDav() {
		// creation de la boite de Dialogue
		this.setTitle("Remote repository");
		this.setLayout(new BorderLayout());

		JPanel pane1 = new JPanel();
		pane1.setLayout(new SpringLayout());
		JLabel l = new JLabel("Repository : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(repertoire);
		pane1.add(repertoire);
		l = new JLabel("Signet : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(signet);
		pane1.add(signet);
		l = new JLabel("Login : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(login);
		pane1.add(login);
		l = new JLabel("Password : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(password);
		pane1.add(password);
		
		SpringUtilities.makeCompactGrid(pane1, 4, 2, // rows, cols
				0, 0, // initX, initY
				2, 2);
		
		this.add(pane1, BorderLayout.CENTER);
		
		repertoire.setText("http://server[:port]/chemin/folder");
		repertoire.setEditable(true);
		signet.setText("Remote repository");
		
		JPanel pane2 = new JPanel();
		pane2.add(new JLabel(""));
		JButton change = new JButton("Create");
		JButton close = new JButton("Cancel");
		change.addActionListener(ab);
		close.addActionListener(ab);
		pane2.add(close);
		pane2.add(change);
		
		this.add(pane2,BorderLayout.SOUTH);
		
		this.setSize(400, 200);
	}

	private void initialiseLocal() {
		// creation de la boite de Dialogue
		this.setTitle("Repository");
		
		this.setLayout(new GridLayout(4, 1));
		JPanel pane1 = new JPanel();
		JPanel pane2 = new JPanel();
		JButton select = new JButton("Select");
		pane1.setLayout(new BorderLayout());
		pane1.add(select,BorderLayout.WEST);
		pane1.add(repertoire,BorderLayout.CENTER);
		pane2.setLayout(new BorderLayout());
		pane2.add(new JLabel("Signet :"),BorderLayout.WEST);
		pane2.add(signet,BorderLayout.CENTER);
		JPanel pane3 = new JPanel();
		pane3.add(new JLabel(""));
		JButton change = new JButton("Create");
		JButton close = new JButton("Cancel");
		change.addActionListener(ab);
		close.addActionListener(ab);
		select.addActionListener(ab);
		pane3.add(close);
		pane3.add(change);
		this.add(new JLabel("Select a folder as repository :"));
		this.add(pane1);
		this.add(pane2);
		this.add(pane3);
		repertoire.setText("No selected");
		repertoire.setEditable(false);
		signet.setText("Local repository");
		
		this.setSize(400, 150);
	}

	private void cancel_clic() {
		dispose();
	}
	
	private void create_clic() {
		Element element = null;
		try{
			element = repositories.addRepositories(repertoire.getText(), this.typeRepository, signet.getText());
			if(typeRepository.equals(RepositorysLocation.LocalRepository)){
				this.repo = new Repository(element);
				repositories.write();
			}
			else if (typeRepository.equals(RepositorysLocation.WebdavRepository)){
				repositories.setRepositoryLogin(element, this.login.getText());
				repositories.setRepositoryPassword(element, this.password.getText());
				this.repo = new RepositoryWebdav(element);
				repositories.write();
			}
			dispose();
		}catch(Exception e){
			e.printStackTrace();
			JOptionPane.showMessageDialog(this,
					"Problems during add Repository\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE);
			if(element!=null){
				repositories.deleteRepository(element);
			}
		}
	}

	private void select_clic() {
		try {
			// selectionner un directory
			// sélection d'un fichier fasta
			File selectedFile;
			JFileChooser fileChooser = new JFileChooser();
			fileChooser.setDialogTitle("Selected the new folder");
			fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			fileChooser.setMultiSelectionEnabled(false);
			int returnValue = fileChooser.showOpenDialog(null);
			if (returnValue == JFileChooser.CANCEL_OPTION)
				throw new FastaException("Changed canceled");
			selectedFile = fileChooser.getSelectedFile();
			repertoire.setText(selectedFile.getAbsolutePath());
		} catch (FastaException e) {
			System.out.println("Stop select file");
		}

	}

	class actions implements ActionListener {
		public void actionPerformed(ActionEvent evt) {
			String composant = evt.getActionCommand();
			if (composant.equalsIgnoreCase("Cancel")) {
				cancel_clic();
			}
			if (composant.equalsIgnoreCase("Select")) {
				select_clic();
			}
			if (composant.equalsIgnoreCase("Create")) {
				create_clic();
			}
		}

	}

	public Repository getRepository() {
		return this.repo;
	};
}
