package fr.inra.pappso.FastaManager.gui;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Hashtable;
import javax.swing.Timer;
import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;
import org.w3c.dom.Element;

import fr.inra.pappso.FastaManager.FastaFile.FastaFile;
import fr.inra.pappso.FastaManager.database.Repository;
import fr.inra.pappso.FastaManager.exception.FastaException;
import fr.inra.pappso.FastaManager.fasta_transforme.FastaTransformer;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_est_to_reverse_complement;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_est_translate_to_3_protein;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_est_translate_to_3_protein_select_orf;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_est_translate_to_6_protein;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_est_translate_to_6_protein_select_orf;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_prot_to_peptide_reverse;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_prot_to_peptide_shuffle;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_prot_to_reverse;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_protein_translate_to_select_orf;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_to_seq_est;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_to_seq_protein;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_transforme;

public class transfert_window extends JDialog {

	private static final long serialVersionUID = 136444L;

	private static final Logger logger = Logger
			.getLogger(transfert_window.class);

	private Repository xml;

	private Hashtable<String, Element> ids;

	private Hashtable<String, seq_transforme> hash_trans;

	private ArrayList<FastaFile> file;

	private seq_transforme transforme;

	private String id_new;

	private String type;

	private FastaTransformer fasta;

	private actions ab = new actions();

	private Timer timer;

	private monthread t;

	private JButton button;

	private JLabel action_label = new JLabel();

	private JLabel entries = new JLabel();

	private JPanel pane2;

	private JComboBox seq_trans_choice;

	public transfert_window(JFrame owner, boolean modal, Repository x,
			String ty, String id, ArrayList<FastaFile> files) {
		super(owner, modal);
		this.xml = x;
		this.type = ty;
		this.id_new = id;
		// this.transforme = t;
		this.file = files;
		// initialise la fenetre

		combo_box_initialise();

		initialise();

		// regle et affiche la fenetre
		setSize(400, 150);
		setLocationRelativeTo(owner);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setVisible(true);
	}

	private void combo_box_initialise() {
		this.hash_trans = new Hashtable<String, seq_transforme>();
		this.seq_trans_choice = new JComboBox();
		if (type.equals("PROT")) {
			seq_trans_choice.addItem("Protein");
			hash_trans.put("Protein", new seq_to_seq_protein());
			seq_trans_choice.addItem("Protein to peptide reverse");
			hash_trans.put("Protein to peptide reverse",
					new seq_prot_to_peptide_reverse());
			seq_trans_choice.addItem("Protein to peptide shuffle");
			hash_trans.put("Protein to peptide shuffle",
					new seq_prot_to_peptide_shuffle());
			seq_trans_choice.addItem("Protein to reverse");
			hash_trans.put("Protein to reverse", new seq_prot_to_reverse());
			seq_trans_choice.addItem("Protein from translate to select orf");
			hash_trans.put("Protein from translate to select orf",
					new seq_protein_translate_to_select_orf());
		} else if (type.equals("EST")) {
			seq_trans_choice.addItem("EST translate to 6 frame with orf");
			hash_trans.put("EST translate to 6 frame with orf",
					new seq_est_translate_to_6_protein_select_orf());
			seq_trans_choice.addItem("EST translate to 3 frame with orf");
			hash_trans.put("EST translate to 3 frame with orf",
					new seq_est_translate_to_3_protein_select_orf());
			seq_trans_choice.addItem("EST translate to 6 frame");
			hash_trans.put("EST translate to 6 frame",
					new seq_est_translate_to_6_protein());
			seq_trans_choice.addItem("EST translate to 3 frame");
			hash_trans.put("EST translate to 3 frame",
					new seq_est_translate_to_3_protein());
			seq_trans_choice.addItem("EST");
			hash_trans.put("EST", new seq_to_seq_est());
			seq_trans_choice.addItem("EST to reverse complement");
			hash_trans.put("EST to reverse complement",
					new seq_est_to_reverse_complement());
		} else {
			seq_trans_choice.addItem("Protein");
			hash_trans.put("Protein", new seq_to_seq_protein());
			seq_trans_choice.addItem("EST translate to 6 frame with orf");
			hash_trans.put("EST translate to 6 frame with orf",
					new seq_est_translate_to_6_protein_select_orf());
			seq_trans_choice.addItem("EST translate to 3 frame with orf");
			hash_trans.put("EST translate to 3 frame with orf",
					new seq_est_translate_to_3_protein_select_orf());
			seq_trans_choice.addItem("EST translate to 6 frame");
			hash_trans.put("EST translate to 6 frame",
					new seq_est_translate_to_6_protein());
			seq_trans_choice.addItem("EST translate to 3 frame");
			hash_trans.put("EST translate to 3 frame",
					new seq_est_translate_to_3_protein());
			seq_trans_choice.addItem("EST");
			hash_trans.put("EST", new seq_to_seq_est());
			seq_trans_choice.addItem("Protein to peptide reverse");
			hash_trans.put("Protein to peptide reverse",
					new seq_prot_to_peptide_reverse());
			seq_trans_choice.addItem("Protein to peptide shuffle");
			hash_trans.put("Protein to peptide shuffle",
					new seq_prot_to_peptide_shuffle());
			seq_trans_choice.addItem("Protein to reverse");
			hash_trans.put("Protein to reverse", new seq_prot_to_reverse());
			seq_trans_choice.addItem("Protein from translate to select orf");
			hash_trans.put("Protein from translate to select orf",
					new seq_protein_translate_to_select_orf());
			seq_trans_choice.addItem("EST to reverse complement");
			hash_trans.put("EST to reverse complement",
					new seq_est_to_reverse_complement());
		}
	}

	private void initialise() {
		// creation de la boite de Dialogue
		this.setTitle("Loading");
		this.setLayout(new GridLayout(3, 1));
		JPanel pane1 = new JPanel();
		pane2 = new JPanel();
		JPanel pane3 = new JPanel();
		pane1.add(action_label);
		pane2.add(seq_trans_choice);
		button = new JButton("select");
		button.addActionListener(ab);
		pane3.add(button);
		this.add(pane1);
		this.add(pane2);
		this.add(pane3);
		action_label.setText("Selected the type of transformation to applied");
		entries.setText("");
	}

	private void new_data() {
		try {
			xml.add_database();
			ids = xml.get_databases();
			if (!ids.containsKey(id_new))
				throw new FastaException("This id : " + id_new
						+ " doesn't exist");
			xml.set_fasta_file(ids.get(id_new), id_new + ".fasta");
			xml.set_entries(ids.get(id_new),
					"" + fasta.get_fasta_outfile_entries());
			xml.set_type(ids.get(id_new), transforme.get_type());
			xml.set_sequence_type(ids.get(id_new),
					transforme.get_sequence_type());
		} catch (Exception e) {
			error_thread(e);
		}
	}

	private void transfert_run() {
		try {
			// selection d'un id libre
			logger.info("start transformation");
			fasta = new FastaTransformer(xml.newFastaWriter());
			/*
			 * // ouverture d'un flux fasta = new fasta_flux();
			 * fasta.set_path_outfile(xml.get_database_repository());
			 * fasta.set_outfile(id_new + ".fasta");
			 */
			for (FastaFile fastaFile : file) {
				// fasta.add_infile(file[i].getAbsolutePath());
				fasta.addFastaFile(fastaFile);
			}

			// demarrage de transert
			timer = new Timer(500, ab);
			timer.setInitialDelay(0);
			timer.start();
			t = new monthread();
			t.setDaemon(true);
			t.start();
		} catch (Exception e) {
			error_thread(e);
		}
	}

	private void cancel_clic(String message) {
		timer.stop();
		if (t.isAlive()) {
			t.stop();
		}
		// t.setUncaughtExceptionHandler(new InterruptedException());
		JOptionPane.showMessageDialog(this, "Problems during database import\n"
				+ message, "Error", JOptionPane.ERROR_MESSAGE);
		dispose();
	}

	private void error_thread(Exception e) {
		timer.stop();
		// t.setUncaughtExceptionHandler(new InterruptedException());
		for (StackTraceElement stack : e.getStackTrace()) {
			logger.error(stack.toString());
		}
		JOptionPane.showMessageDialog(this, "Problems during database import\n"
				+ e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
		dispose();
	}

	private void finish() {
		timer.stop();
		new_data();
		JOptionPane.showMessageDialog(this, "Analyse finish", "Message",
				JOptionPane.INFORMATION_MESSAGE);

		this.dispose();
	}

	private void ok_clic() {
		// prendre le choix de la combo_box
		String temp = (String) seq_trans_choice.getSelectedItem();
		transforme = (seq_transforme) hash_trans.get(temp);
		// rééditer la fenetre de chargement
		pane2.remove(seq_trans_choice);
		pane2.add(entries);
		entries.setText("");
		// lancer le tansfert
		transfert_run();
	}

	class actions implements ActionListener {
		public void actionPerformed(ActionEvent evt) {
			if (evt.getSource() == button) {
				String composant = evt.getActionCommand();
				if (composant.equalsIgnoreCase("cancel")) {
					cancel_clic("Analyse canceled");
				}
				if (composant.equalsIgnoreCase("select")) {
					ok_clic();
				}
			} else if (evt.getSource() == timer) {
				action_label.setText("Importation in progress");
				button.setText("cancel");
				entries.setText("" + fasta.get_fasta_outfile_entries());
				repaint();
				if (!t.isAlive())
					finish();
			}

		}
	};

	class monthread extends Thread {
		public void run() {
			try {
				fasta.transfert_sequences(transforme);
			} catch (InterruptedException e) {
			} catch (Exception e) {
				error_thread(e);
			}
		}
	};

}
