
package fr.inra.pappso.FastaManager.sequence_transforme;
import fr.inra.pappso.FastaManager.exception.FastaException;

import java.util.Hashtable;

public class table_codon {
	//variable
	private Hashtable<String,String> table_codon = new Hashtable<String,String>();
	
	// constructeur
	public table_codon() {
		initialise();
	}
	
	public String get_aa_to_codon(String codon) throws FastaException{
		String AA = null;
		if (codon.length()!=3)
			throw new FastaException("The codon : " + codon+" have not the good size");
		if (codon.contains("N"))
			return("X");
		if (!this.table_codon.containsKey(codon))
			throw new FastaException("Impossible to traducted the codon :" + codon);
		AA = (String)this.table_codon.get(codon);
		return (AA);
	}
	
	private void initialise (){
		// table des codons
		this.table_codon.put("TTT", "F");
		this.table_codon.put("TTC", "F");
		this.table_codon.put("TTA", "L");
		this.table_codon.put("TTG", "L");
		this.table_codon.put("TCT", "S");
		this.table_codon.put("TCC", "S");
		this.table_codon.put("TCA", "S");
		this.table_codon.put("TCG", "S");
		this.table_codon.put("TAT", "Y");
		this.table_codon.put("TAC", "Y");
		this.table_codon.put("TAA", "-");
		this.table_codon.put("TAG", "-");
		this.table_codon.put("TGT", "C");
		this.table_codon.put("TGC", "C");
		this.table_codon.put("TGA", "-");
		this.table_codon.put("TGG", "W");
		this.table_codon.put("CTT", "L");
		this.table_codon.put("CTC", "L");
		this.table_codon.put("CTA", "L");
		this.table_codon.put("CTG", "L");
		this.table_codon.put("CCT", "P");
		this.table_codon.put("CCC", "P");
		this.table_codon.put("CCA", "P");
		this.table_codon.put("CCG", "P");
		this.table_codon.put("CAT", "H");
		this.table_codon.put("CAC", "H");
		this.table_codon.put("CAA", "Q");
		this.table_codon.put("CAG", "Q");
		this.table_codon.put("CGT", "R");
		this.table_codon.put("CGC", "R");
		this.table_codon.put("CGA", "R");
		this.table_codon.put("CGG", "R");
		this.table_codon.put("ATT", "I");
		this.table_codon.put("ATC", "I");
		this.table_codon.put("ATA", "I");
		this.table_codon.put("ATG", "M");
		this.table_codon.put("ACT", "T");
		this.table_codon.put("ACC", "T");
		this.table_codon.put("ACA", "T");
		this.table_codon.put("ACG", "T");
		this.table_codon.put("AAT", "N");
		this.table_codon.put("AAC", "N");
		this.table_codon.put("AAA", "K");
		this.table_codon.put("AAG", "K");
		this.table_codon.put("AGT", "S");
		this.table_codon.put("AGC", "S");
		this.table_codon.put("AGA", "R");
		this.table_codon.put("AGG", "R");
		this.table_codon.put("GTT", "V");
		this.table_codon.put("GTC", "V");
		this.table_codon.put("GTA", "V");
		this.table_codon.put("GTG", "V");
		this.table_codon.put("GCT", "A");
		this.table_codon.put("GCC", "A");
		this.table_codon.put("GCA", "A");
		this.table_codon.put("GCG", "A");
		this.table_codon.put("GAT", "D");
		this.table_codon.put("GAC", "D");
		this.table_codon.put("GAA", "E");
		this.table_codon.put("GAG", "E");
		this.table_codon.put("GGT", "G");
		this.table_codon.put("GGC", "G");
		this.table_codon.put("GGA", "G");
		this.table_codon.put("GGG", "G");
		// fin de table

	}
}
