package fr.inra.pappso.FastaManager.fasta_transforme;

import org.apache.log4j.Logger;

import fr.inra.pappso.FastaManager.fasta_transforme.input.FastaReader;
import fr.inra.pappso.FastaManager.fasta_transforme.output.FastaWriter;
import fr.inra.pappso.FastaManager.sequence.sequence;
import fr.inra.pappso.FastaManager.sequence_transforme.seq_transforme;

public class FastaInputStreamTransformer implements FastaReader {
	private static final Logger logger = Logger
			.getLogger(FastaInputStreamTransformer.class);
	private FastaWriter seqWriter;
	private seq_transforme transformer;
	private int fasta_outfile_entries = 0;

	public FastaInputStreamTransformer(FastaWriter seqWriter,
			seq_transforme transforme) {
		this.seqWriter = seqWriter;
		this.transformer = transforme;
	}

	public void newFastaSequence(String header, String strSequence)
			throws Exception {
		sequence seq = new sequence();
		String[] descriptions = new String[2];

		descriptions = split_description(header);

		seq.set_accession(descriptions[0]); // remplie l'objet sequence
		seq.set_description(descriptions[1]); // remplie l'objet sequence
		seq.set_sequence(strSequence);

		sequence[] result;
		result = this.transformer.transforme(seq);
		// applique l'objet transformateur
		for (int j = 0; j < result.length; j++) {
			//logger.debug("write "+result[j].get_accession());
			if (result[j].get_accession() != null) {
				//logger.debug("write "+result[j].get_accession());
				seqWriter.write(result[j]);
				fasta_outfile_entries++;// Ajout d'une entrée
			}
		}

	}

	private String[] split_description(String L) {
		String[] lines = L.split("\\s+");
		String[] descriptions = new String[2];
		descriptions[0] = lines[0];
		descriptions[1] = "";
		for (int i = 1; i < lines.length; i++) {
			descriptions[1] = descriptions[1].concat(" " + lines[i]);
		}
		return (descriptions);
	}

	public int get_fasta_outfile_entries() {
		return fasta_outfile_entries;
	}
}
