package fr.inra.pappso.FastaManager.fasta_transforme.output;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

import org.apache.log4j.Logger;

import fr.inra.pappso.FastaManager.exception.FastaException;

public class FastaOutputFile extends FastaOutputStream {
	private static final Logger logger = Logger
			.getLogger(FastaOutputFile.class);

	public FastaOutputFile(String filename) throws FileNotFoundException,
			FastaException, UnsupportedEncodingException {
		super();
		File file = new File(filename);
		if (file.exists()) {
			String message = "output " + file.getAbsolutePath()
					+ " already exists";
			logger.error(message);
			throw new FastaException(message);
		}
		logger.debug("creating file " + file.getAbsolutePath());

		this.out = new OutputStreamWriter(new FileOutputStream(
				file.getAbsolutePath()), "Cp850");
	}
}
