package fr.inra.pappso.FastaManager.fasta_transforme.output;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.URL;

import org.apache.log4j.Logger;

import com.googlecode.sardine.Sardine;

import fr.inra.pappso.FastaManager.exception.FastaException;

public class FastaOutputSardine extends FastaOutputStream {
	private static final Logger logger = Logger
			.getLogger(FastaOutputSardine.class);

	private OutputSardineThread sardineThread = null;

	public FastaOutputSardine(Sardine sardine, URL urlOutput)
			throws IOException, FastaException {
		super();
		if (sardine.exists(urlOutput.toString())) {
			String message = "output " + urlOutput.toString()
					+ " already exists";
			logger.error(message);
			throw new FastaException(message);
		}
		sardineThread = new OutputSardineThread(sardine, urlOutput);
		this.out = new OutputStreamWriter(sardineThread.getOutputStream(),
				"Cp850");
		sardineThread.start();
	}

	public void close() throws IOException {
		logger.debug("close");
		sardineThread.close();
	}
}
