package fr.inra.pappso.FastaManager.fasta_transforme.output;

import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

import org.apache.log4j.Logger;

import fr.inra.pappso.FastaManager.sequence.sequence;



public class FastaOutputStream implements FastaWriter {
	private static final Logger logger = Logger
			.getLogger(FastaOutputStream.class);

	protected OutputStreamWriter out = null;

	public FastaOutputStream(OutputStream out) throws UnsupportedEncodingException {
		this.out = new OutputStreamWriter(out, "Cp850");
	}

	protected FastaOutputStream() {
	}

	public void write(sequence sequence) throws Exception {
		if (this.out == null) {
			logger.error("out is null");
		}
		if (sequence == null) {
			logger.error("sequence is null");
		}

		this.out.write(sequence.get_fasta());

	}

	public void close() throws IOException {
		if (this.out == null) {
			logger.error("out is null");
		}
		this.out.close();
	}

}
