package fr.inra.pappso.FastaManager.sequence_transforme;

import java.util.Random;

import fr.inra.pappso.FastaManager.sequence.sequence;
import fr.inra.pappso.FastaManager.sequence.sequence_prot;

public class seq_prot_to_peptide_shuffle extends seq_transforme {
	private seq_transforme trans;
	private Random rand;
	
	public seq_prot_to_peptide_shuffle() {
		this.seq_out = new sequence_prot[1];
		this.trans = new seq_to_seq_protein();
		this.rand = new Random(); // constructeur
	}

	public sequence[] transforme(sequence S) throws Exception {
		this.seq_out = this.trans.transforme(S);
		String sequence = "";
		String seq = this.seq_out[0].get_sequence();
		seq = seq.replaceAll("K", "K_");
		seq = seq.replaceAll("R", "R_");
		String [] S_split = seq.split("[_]");
		for (int o = 0; o<S_split.length;o++){
			sequence = sequence + shuffle(S_split[o]);
		}
		this.seq_out[0].set_sequence(sequence);
		this.seq_out[0].set_accession(this.seq_out[0].get_accession()
				+ "|PepShuffle" );
		return (this.seq_out);
	}
	public String get_type(){
		return("Protein to peptide shuffle");
	}
	public String get_sequence_type(){
		return("PROT");
	}
	private String shuffle (String ST){
		String ST_random = "";
		int lengfixe = ST.length();
		for (int k = 0;k<lengfixe-1;k++){
		int i = rand.nextInt(ST.length()-1); // génération
		ST_random=ST_random+ST.charAt(i);		
		String STtr= ST;
		int leng = ST.length();
		ST = ST.substring(0, i)+STtr.substring(i+1, leng);
		}
		ST_random=ST_random+ST;
		return (ST_random);
	}

}
